clear all
a1=input('Enter the field size:','s');
a2=input('Enter the number of mines:','s');
a3=input('Enter the number of ants:','s');
a=str2num(a1); %The field Size
mines=str2num(a2); %The number of Mines
ants=str2num(a3); %The number of ants foraging
field=zeros(a,a); %The field as a two dimentional matrix containing valus 1 and 0 for mine locations and empty spots
f=zeros(mines,2); %The location of mines as ordered pairs on the two dimentional fields
figure(1)
clf
add=zeros(7); %The scent spread matrix: scent intensity spread by an ant when it detects a mine
aw=.3; %The exponent for the falling scent spread intensity 
len=3; %The length or dimensions of the scent spread
for i=-len:len
    for j=-len:len
        for n=0:len
            if((abs(i)==n)|(abs(j)==n))
                add(i+(len+1),j+(len+1))=aw^(n+1);
            end
        end
    end
end

%Distribute the mines on the minefield (Uniform Two-Dimensional Distribution)
aaaa=0;num=0.2;
for i=1:mines
    f(i,1)=randint(1,1,[2 a-2]);
    f(i,2)=randint(1,1,[2 a-2]);
    if(field(f(i,1),f(i,2))~=1)
        field(f(i,1),f(i,2))=1;
    else
        aaaa=aaaa+1;
    end
end

%Plot the mine over the field
plot(f(:,1),f(:,2),'hk');
axis([0 a 0 a])
hold on
  
mines=mines-aaaa;
ff1=0;ff2=0;ff3=0;
scentfield=zeros(a,a); %The scentfield matrix (dimensions same as the minefield)
pherfield=zeros(a,a);
inc=zeros(a,a);
antpos=randint(ants,1,[2,a-1]); %The initial position of the ants (along the four boundries)
antinit=zeros(ants,2); %The position of the ants as they forage
North=zeros(ants,1);East=zeros(ants,1);patch=-1*ones(ants,1); %Diractional vectors to guide motion
aa=zeros(ants,1);bb=zeros(ants,1);

%Place the ants along the boundry initailly
for i=1:ants
    if(mod(i,4)==1)
    antinit(i,1)=1;antinit(i,2)=randint(1,1,[2,a-1]);
    North(i)=-1;aa(i)=1;
    elseif(mod(i,4)==2)
    antinit(i,1)=randint(1,1,[2,a-1]);antinit(i,2)=1;
    East(i)=1;bb(i)=1;
    elseif(mod(i,4)==3)
    antinit(i,1)=a;antinit(i,2)=randint(1,1,[2,a-1]);
    North(i)=1;aa(i)=-1;
    else
    antinit(i,1)=randint(1,1,[2,a-1]);antinit(i,2)=a;
    East(i)=-1;bb(i)=-1;
    end
end

newpos=zeros(ants,2); %The arry of positions, the ants would be targeting to move to from their current position
counter=zeros(ants,1); 
firsttag=zeros(ants,1); % A variable to indicate the transition from foraging to waiting
checkpoint=zeros(ants,2,3); %The array of locations immediately adjacent to the ant location which would be scanned for mines of scent
checkpoint(:,:,1)=antinit;
mine=zeros(mines,1);
cleared=0; % The number of cleared mined at any point
aaa=zeros(ants,1); %Internal variables to assist foraging
bbb=zeros(ants,1); %Internal variables to assist foraging
behavior=zeros(ants,1); % The array of the behavios of individual ants
%Behavior 0: Foraging
%Behavior 1: Trail following
%Behavior 2: Waiting
b=zeros(ants,1);
bpos=zeros(ants,2);
count=-1; % Iteration Count
checkpos=zeros(a);
dir=zeros(ants,2);
withdraw=zeros(ants,1);

% The Mine Detection task begins
while cleared~=mines
    count=count+1;
    w=figure(11);
    getframe(w);
    clf
    
    %Eradicate stray scent concentrations
    for i=1:a
        for k=1:a
            if(scentfield(i,k)<0.001)
            scentfield(i,k)=0;
            end
        end
    end
    hold on
    
    %Plot the updated ant locations
    plot(antinit(:,1),antinit(:,2),'*b');
    hold on
    
    %Plot the updated mine locations
    for i=1:mines
        if(mine(i)==1)
            plot(f(i,1),f(i,2),'hr')
        else
            plot(f(i,1),f(i,2),'hk')
        end
    end
    hold on
    
    %The individual ant's activity starts
    for j=1:ants
        checkpos=zeros(a);
        %Update the checkpoints
        for i=1:ants
            checkpos(checkpoint(i,1,1),checkpoint(i,2,1))=checkpos(checkpoint(i,1,1),checkpoint(i,2,1))+1;
        end 
        
        % Get directional information and check three adjacent points for mine or scent
        if((behavior(j)==0))
                if(North(j)==0)
                    if(East(j)==1)
                        checkpoint(j,1,1)=antinit(j,1);
                        checkpoint(j,2,1)=antinit(j,2)+1;
                    else
                        checkpoint(j,1,1)=antinit(j,1);
                        checkpoint(j,2,1)=antinit(j,2)-1; 
                    end
                    checkpoint(j,1,2)=checkpoint(j,1,1)+1;
                    checkpoint(j,2,2)=checkpoint(j,2,1);
                    checkpoint(j,1,3)=checkpoint(j,1,1)-1;
                    checkpoint(j,2,3)=checkpoint(j,2,1);
                else
                    if(North(j)==1)
                        checkpoint(j,1,1)=antinit(j,1)-1;
                        checkpoint(j,2,1)=antinit(j,2);
                    else
                        checkpoint(j,1,1)=antinit(j,1)+1;
                        checkpoint(j,2,1)=antinit(j,2); 
                    end
                    checkpoint(j,1,2)=checkpoint(j,1,1);
                    checkpoint(j,2,2)=checkpoint(j,2,1)+1;
                    checkpoint(j,1,3)=checkpoint(j,1,1);
                    checkpoint(j,2,3)=checkpoint(j,2,1)-1;
                end
                
                %If no mine or scent or mine is found proceed with foraging
                if(behavior(j)==0)
                for i=1:3
                if((checkpoint(j,1,i)>0)&(checkpoint(j,1,i)<=a)&(checkpoint(j,2,i)>0)&(checkpoint(j,2,i)<=a))
                if(scentfield(checkpoint(j,1,i),checkpoint(j,2,i))~=0)
                   behavior(j)=1;
                   patch(j)=0;
                   checkpoint(j,:,1)=checkpoint(j,:,i);
                   antinit(j,:)=checkpoint(j,:,1);
                   break
                end
                end
                end
                end
                
                for i=1:3
                if((checkpoint(j,1,i)>0)&(checkpoint(j,1,i)<=a)&(checkpoint(j,2,i)>0)&(checkpoint(j,2,i)<=a))
                if((field(checkpoint(j,1,i),checkpoint(j,2,i))==1))
                    if(inc(checkpoint(j,1,i),checkpoint(j,2,i))~=1)
                    behavior(j)=2;
                    firsttag(j)=1;
                    patch(j)=0;
                    % If a mine is detected when foraging spread the scent spread
                    ad=scentfield(max(1,checkpoint(j,1,i)-3):min(a,checkpoint(j,1,i)+3),max(1,checkpoint(j,2,i)-3):min(a,checkpoint(j,2,i)+3));
                    n1=1;n2=7;n3=1;n4=7;
                    if((checkpoint(j,1,i)-4)<0)
                        n1=abs(checkpoint(j,1,i)-5);
                    end
                    if((checkpoint(j,2,i)-4)<0)
                        n3=abs(checkpoint(j,2,i)-5);
                    end
                    if((a-checkpoint(j,1,i))<3)
                        n2=8-(a-checkpoint(j,1,i));
                    end
                    if((a-checkpoint(j,2,i))<3)
                        n4=8-(a-checkpoint(j,2,i));
                    end
                    anss=add(n1:n2,n3:n4)+ad;
                    scentfield(max(1,checkpoint(j,1,i)-3):min(a,checkpoint(j,1,i)+3),max(1,checkpoint(j,2,i)-3):min(a,checkpoint(j,2,i)+3))=anss;
                   
                    inc(checkpoint(j,1,i),checkpoint(j,2,i))=1;
                    %antinit(j,:)=checkpoint(j,:,i);
                    checkpoint(j,:,1)=checkpoint(j,:,i);break
                    end
                end
                end
                end
                
                if(behavior(j)==0)
                if(scentfield(checkpoint(j,1,1),checkpoint(j,2,1))~=0)
                    behavior(j)=1;
                    patch(j)=0;
                    antinit(j,:)=checkpoint(j,:,1);
                end
                end
                               
                % Determine the next global target points with respect to the cognitive maps
                if(patch(j)==0)
                   if(antinit(j,1)<0.5*a+1)
                        if(antinit(j,2)<0.5*a+1)
                            aaa(j)=1;
                            bbb(j)=1;
                        else
                            aaa(j)=1;
                            bbb(j)=0;
                        end 
                    else
                        if(antinit(j,2)<0.5*a+1)
                            aaa(j)=0;
                            bbb(j)=1;
                        else
                            aaa(j)=0;
                            bbb(j)=0;
                        end 
                  end 
                  newpos(j,1)=randint(1,1,[aaa(j)*(0.5*a)+2,aaa(j)*(0.5*a)+(0.5*a-1)-1]);
                  newpos(j,2)=randint(1,1,[bbb(j)*(0.5*a)+2,bbb(j)*(0.5*a)+(0.5*a-1)-1]);
                  dir(j,:)=[1,2];
                  if(withdraw(j)==1)
                    dir(j,:)=randperm(2);
                  end
                  aa(j)=(newpos(j,dir(j,1))-antinit(j,dir(j,1)));
                  bb(j)=(newpos(j,dir(j,2))-antinit(j,dir(j,2)));
                  patch(j)=-abs(newpos(j,1)-antinit(j,1))-abs(newpos(j,2)-antinit(j,2));
                  withdraw(j)=0;
              end
                 
              if(aa(j)==0)
                  East(j)=(isequal(dir(j,1),1)*sign(bb(j)));
                  North(j)=-(isequal(dir(j,1),2)*sign(bb(j)));
                  bb(j)=bb(j)-sign(bb(j));
              else
                  North(j)=-(sign(aa(j))*isequal(dir(j,1),1));
                  East(j)=(isequal(dir(j,1),2)*sign(aa(j)));
                  aa(j)=aa(j)-sign(aa(j));
              end
                  
               if(behavior(j)==0)
               antinit(j,:)=checkpoint(j,:,1);
               patch(j)=patch(j)+1;
               end
         
         % If in trail following mode continue scanning the scent for increase in concentration and for mines    
         elseif(behavior(j)==1)
                   patch(j)=0;
                   for ii=(max(1,antinit(j,1)-1)):1:min(a,(antinit(j,1)+1))
                       if(field(checkpoint(j,1,1),checkpoint(j,2,1))==1)
                           behavior(j)=2;
                           patch(j)=0;
                           break
                       end
              
                       for jj=(max(1,antinit(j,2)-1)):1:min(a,(antinit(j,2)+1))
                           if(scentfield(ii,jj)>b(j))
                               if(field(ii,jj)~=1)
                                     b(j)=scentfield(ii,jj);
                                     bpos(j,:)=[ii  jj];
                                     checkpoint(j,:,1)=[ii  jj];
                               else
                                     behavior(j)=2;
                                     checkpoint(j,:,1)=[ii  jj];
                                     break
                               end
                           end
                       end
                   end
                   if(sum(bpos(j,:))>0)
                   antinit(j,:)=bpos(j,:);
                   b(j)=0;
                   end
                   if(scentfield(antinit(j,1),antinit(j,2))==0)
                       behavior(j)=0;
                       patch(j)=0;
                   end
         % If in waiting behavior, confirm for four ants to reach the mine location and defuse the mine, erradicate the scent field around the defused mine         
         elseif(behavior(j)==2)
               behavior(j)=2;
               counter(j)=counter(j)+1;
               patch(j)=0;
               
                    if(sum(behavior)>=8)
                      [ff1,ff2]=find(field==1);
                      c=size(ff1);
                    for i=1:c(1)
                      var=checkpos(ff1(i),ff2(i));
                      
                    if(var>=4)
                      ff3=find((checkpoint(:,1,1)==ff1(i))&(checkpoint(:,2,1)==ff2(i))); 
                      h=size(ff3,1);
                      cleared=cleared+1;
                      for p=1:h
                        behavior(ff3(p))=0;
                        counter(h)=0;
                      end
                      ad1=scentfield(max(1,ff1(i)-3):min(a,ff1(i)+3),max(1,ff2(i)-3):min(a,ff2(i)+3));
                      nn1=1;nn2=7;nn3=1;nn4=7;
                        if((ff1(i)-5)<0)
                            nn1=abs(ff1(i)-5);
                        end
                        if((ff2(i)-4)<0)
                            nn3=abs(ff2(i)-5);
                        end
                        if((a-ff1(i))<3)
                            nn2=8-(a-ff1(i));
                        end
                        if((a-ff2(i))<3)
                            nn4=8-(a-ff2(i));
                        end
                      anss1=ad1-add(nn1:nn2,nn3:nn4);
                      scentfield(max(1,ff1(i)-3):min(a,ff1(i)+3),max(1,ff2(i)-3):min(a,ff2(i)+3))=anss1;
                   
                      field(ff1(i),ff2(i))=0;mine(find((f(:,1)==ff1(i))&(f(:,2)==ff2(i))))=1;
                   end
                   end
                   end
                   
                   %If threshold time (time for waiting) exceed 50 iteration units change behavior from waiting to foraging
                   if(counter(j)>50)
                       behavior(j)=0;
                       counter(j)=0;
                       withdraw(j)=1;
                       North(j)=0;East(j)=0;
                       inc(checkpoint(j,1,1),checkpoint(j,2,1))=0;
                       %if(firsttag(j)==1)
                       ad1=scentfield(max(1,checkpoint(j,1,1)-3):min(a,checkpoint(j,1,1)+3),max(1,checkpoint(j,2,1)-3):min(a,checkpoint(j,2,1)+3));
                       nn1=1;nn2=7;nn3=1;nn4=7;
                        if((checkpoint(j,1,1)-5)<0)
                            nn1=abs(checkpoint(j,1,1)-5);
                        end
                        if((checkpoint(j,2,1)-4)<0)
                            nn3=abs(checkpoint(j,2,1)-5);
                        end
                        if((a-checkpoint(j,1,1))<3)
                            nn2=8-(a-checkpoint(j,1,1));
                        end
                        if((a-checkpoint(j,2,1))<3)
                            nn4=8-(a-checkpoint(j,1,1));
                        end
                       anss1=ad1-add(nn1:nn2,nn3:nn4);
                       scentfield(max(1,checkpoint(j,1,1)-3):min(a,checkpoint(j,1,1)+3),max(1,checkpoint(j,2,1)-3):min(a,checkpoint(j,2,1)+3))=anss1;
                    end
               end
           end
       end
       
% Plot all the defused mines
plot(f(:,1),f(:,2),'hr')
hold on
count